javax.faces.view

## Class StateManagementStrategy

- java.lang.Object
- - javax.faces.view.StateManagementStrategy

-     public abstract class StateManagementStrategy
      extends Object

  Encapsulate the saving and restoring of the view to enable the VDL to take over the responsibility for handling this feature. Because `ViewDeclarationLanguage.getStateManagementStrategy(javax.faces.context.FacesContext, java.lang.String)` is required to return `null` for JSP views and non-`null` for views authored in Facelets for JSF 2, this specification only applys to Facelets for JSF 2.

  Implementations must call `UIComponent.visitTree(javax.faces.component.visit.VisitContext, javax.faces.component.visit.VisitCallback)` on the `UIViewRoot` to perform the saving and restoring of the view in the `saveView(javax.faces.context.FacesContext)` and `restoreView(javax.faces.context.FacesContext, java.lang.String, java.lang.String)` methods, respectively.

  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StateManagementStrategy()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract UIViewRoot` | `restoreView(FacesContext context, String viewId, String renderKitId)` Restore the state of the view with information in the request.
    `abstract Object` | `saveView(FacesContext context)` Return the state of the current view in an `Object` that implements `Serializable` and can be passed to `java.io.ObjectOutputStream.writeObject()` without causing a `java.io.NotSerializableException` to be thrown. The default implementation must perform the following algorithm or its semantic equivalent, explicitly performing all the steps listed here.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StateManagementStrategy

          public StateManagementStrategy()

  - ### Method Detail

    - #### saveView

          public abstract Object saveView(FacesContext context)

      Return the state of the current view in an `Object` that implements `Serializable` and can be passed to `java.io.ObjectOutputStream.writeObject()` without causing a `java.io.NotSerializableException` to be thrown. The default implementation must perform the following algorithm or its semantic equivalent, explicitly performing all the steps listed here.

      1. If the `UIViewRoot` of the current view is marked `transient`, return `null` immediately.

      2. Traverse the view and verify that each of the client ids are unique. Throw `IllegalStateException` if more than one client id are the same.

      3. Visit the tree using `UIComponent.visitTree(javax.faces.component.visit.VisitContext, javax.faces.component.visit.VisitCallback)`. For each node, call `StateHolder.saveState(javax.faces.context.FacesContext)`, saving the returned `Object` in a way such that it can be restored given only its client id. Special care must be taken to handle the case of components that were added or deleted programmatically during this lifecycle traversal, rather than by the VDL.

      The implementation must ensure that the `StateHolder.saveState(javax.faces.context.FacesContext)` method is called for each node in the tree.

      The data structure used to save the state obtained by executing the above algorithm must be `Serializable`, and all of the elements within the data structure must also be `Serializable`.

      Parameters:
        `context` - the `FacesContext` for this request.
      Since:
        2.0

    - #### restoreView

          public abstract UIViewRoot restoreView(FacesContext context,
                               String viewId,
                               String renderKitId)

      Restore the state of the view with information in the request. The default implementation must perform the following algorithm or its semantic equivalent.

      1. As in the case of restore view on an initial request, the view metadata must be restored and properly handled as well. Obtain the `ViewMetadata` for the current `viewId`, and from that call `ViewMetadata.createMetadataView(javax.faces.context.FacesContext)`. Store the resultant `UIViewRoot` in the `FacesContext`. Obtain the state of the `UIViewRoot` from the state `Object` returned from `ResponseStateManager.getState(javax.faces.context.FacesContext, java.lang.String)` and pass that to `UIViewRoot.restoreViewScopeState(javax.faces.context.FacesContext, java.lang.Object)`.

         Build the view from the markup. For all components in the view that do not have an explicitly assigned id in the markup, the values of those ids must be the same as on an initial request for this view. This view will not contain any components programmatically added during the previous lifecycle run, and it will contain components that were programmatically deleted on the previous lifecycle run. Both of these cases must be handled.

      2. Call `ResponseStateManager.getState(javax.faces.context.FacesContext, java.lang.String)` to obtain the data structure returned from the previous call to `saveView(javax.faces.context.FacesContext)`.

      3. Visit the tree using `UIComponent.visitTree(javax.faces.component.visit.VisitContext, javax.faces.component.visit.VisitCallback)`. For each node, call `StateHolder.restoreState(javax.faces.context.FacesContext, java.lang.Object)`, passing the state saved corresponding to the current client id.

      4. Ensure that any programmatically deleted components are removed.

      5. Ensure any programmatically added components are added.

      The implementation must ensure that the `StateHolder.restoreState(javax.faces.context.FacesContext, java.lang.Object)` method is called for each node in the tree, except for those that were programmatically deleted on the previous run through the lifecycle.

      Parameters:
        `context` - the `FacesContext` for this request
        `viewId` - the view identifier for which the state should be restored
        `renderKitId` - the render kit id for this state.
      Since:
        2.0

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.